Loading...
Searching...
No Matches
EST_TrackMap Class Reference

`#include <include/EST_TrackMap.h>`

Inheritance diagram for EST_TrackMap:
[legend]
Collaboration diagram for EST_TrackMap:
[legend]

## Classes

struct | ChannelMappingElement
| structure for the table. More...

## ChannelMapping

An auxiliary type used just to define static EST_TrackMaps. Defining one of these and then converting it to an EST_TrackMap is, unfortunately, the only way C++ allows us to define a constant EST_TrackMap.
typedef EST_THandle< EST_TrackMap, EST_TrackMap > | P
| Table of type to position pairs.
class | EST_Track
ostream & | operator<< (ostream &st, const EST_TrackMap &m)
| EST_TrackMap (int refcount)
| Creation function used by friends to create refcounted maps.
| EST_TrackMap (const EST_TrackMap *parent, int offset, int refcount)
| Creation function used by friends to create sub-track maps.
void | copy (EST_TrackMap &from)
| copy an exiting map.
void | init (void)
| Initialise the map.
short | get_parent (EST_ChannelType type) const
| EST_TrackMap (void)
| Default constructor.
| EST_TrackMap (EST_TrackMap &from, int refcount)
| Copy the mapping.
| EST_TrackMap (struct ChannelMappingElement map[])
| Create from static table.
void | clear (void)
| Empty the map.
void | set (EST_ChannelType type, short pos)
| Record the position of a channel.
short | get (EST_ChannelType type) const
| Get the position of a channel.
short | operator() (EST_ChannelType type) const
| Get the position of a channel.
bool | has_channel (EST_ChannelType type) const
| Does the mapping contain a position for this channel?
short | last_channel (void) const
| Returns the index of the last known channel.
EST_ChannelType | channel_type (unsigned short channel) const
| Returns the type of the channel at the given position.
EST_TrackMap * | object_ptr ()
const EST_TrackMap * | object_ptr () const

## Additional Inherited Members

Public Member Functions inherited from EST_Handleable
int | refcount (void) const
void | start_refcounting (int initial=0)
void | inc_refcount (void)
void | dec_refcount (void)
int | is_unreferenced (void) const
int | is_refcounted (void) const

## Detailed Description

Track maps provide a mapping from symbolic track names to the actual position of the information within a track frame. The symbolic names are defined by the EST_ChannelType enumerated type.

Track maps can be declared statically by code which always uses tracks of a given style, or they can be built at run time as is done by lpc_analysis to record whichinformation the user has requested. Finally they can be constructed by the Track itself from the names of the channels, for instance when a track has just been read in from a file.

See also
  EST_Track
  EST_ChannelType
  EST_TrackMap:example

Author
  Richard Caley rjc@c.nosp@m.str..nosp@m.ed.ac.nosp@m..uk

Version

Id
  EST_TrackMap.h,v 1.4 2004/09/29 08:24:17 robert Exp

Definition at line 62 of file EST_TrackMap.h.

## Member Typedef Documentation

## P

typedef EST_THandle<EST_TrackMap,EST_TrackMap> EST_TrackMap::P

Table of type to position pairs.

Definition at line 82 of file EST_TrackMap.h.

## Constructor & Destructor Documentation

## EST_TrackMap() [1/5]

EST_TrackMap::EST_TrackMap | ( | int | refcount | ) |

protected

Creation function used by friends to create refcounted maps.

Definition at line 73 of file EST_TrackMap.cc.

## EST_TrackMap() [2/5]

EST_TrackMap::EST_TrackMap | ( | const EST_TrackMap * | parent,
|  | int | offset,
|  | int | refcount )

protected

Creation function used by friends to create sub-track maps.

Definition at line 80 of file EST_TrackMap.cc.

## EST_TrackMap() [3/5]

EST_TrackMap::EST_TrackMap | ( | void |  | ) |

Default constructor.

Definition at line 67 of file EST_TrackMap.cc.

## EST_TrackMap() [4/5]

EST_TrackMap::EST_TrackMap | ( | EST_TrackMap & | from,
|  | int | refcount )

Copy the mapping.

Definition at line 89 of file EST_TrackMap.cc.

## EST_TrackMap() [5/5]

EST_TrackMap::EST_TrackMap | ( | struct ChannelMappingElement | map[] | ) |

Create from static table.

Definition at line 96 of file EST_TrackMap.cc.

## ~EST_TrackMap()

EST_TrackMap::~EST_TrackMap | ( |  | ) |

Definition at line 105 of file EST_TrackMap.cc.

## Member Function Documentation

## copy()

void EST_TrackMap::copy | ( | EST_TrackMap & | from | ) |

protected

copy an exiting map.

Definition at line 53 of file EST_TrackMap.cc.

## init()

void EST_TrackMap::init | ( | void |  | ) |

protected

Initialise the map.

Definition at line 60 of file EST_TrackMap.cc.

## get_parent()

short EST_TrackMap::get_parent | ( | EST_ChannelType | type | ) | const

protected

Definition at line 109 of file EST_TrackMap.cc.

## clear()

void EST_TrackMap::clear | ( | void |  | ) |

Empty the map.

Definition at line 47 of file EST_TrackMap.cc.

## set()

void EST_TrackMap::set | ( | EST_ChannelType | type,
|  | short | pos )

inline

Record the position of a channel.

Definition at line 133 of file EST_TrackMap.h.

## get()

short EST_TrackMap::get | ( | EST_ChannelType | type | ) | const

inline

Get the position of a channel.

Definition at line 137 of file EST_TrackMap.h.

## operator()()

short EST_TrackMap::operator() | ( | EST_ChannelType | type | ) | const

inline

Get the position of a channel.

Definition at line 141 of file EST_TrackMap.h.

## has_channel()

bool EST_TrackMap::has_channel | ( | EST_ChannelType | type | ) | const

inline

Does the mapping contain a position for this channel?

Definition at line 145 of file EST_TrackMap.h.

## last_channel()

short EST_TrackMap::last_channel | ( | void |  | ) | const

Returns the index of the last known channel.

Definition at line 135 of file EST_TrackMap.cc.

## channel_type()

EST_ChannelType EST_TrackMap::channel_type | ( | unsigned short | channel | ) | const

Returns the type of the channel at the given position.

Definition at line 121 of file EST_TrackMap.cc.

## object_ptr() [1/2]

EST_TrackMap * EST_TrackMap::object_ptr | ( |  | ) |

inline

Definition at line 155 of file EST_TrackMap.h.

## object_ptr() [2/2]

const EST_TrackMap * EST_TrackMap::object_ptr | ( |  | ) | const

inline

Definition at line 156 of file EST_TrackMap.h.

## Friends And Related Symbol Documentation

## EST_Track

friend class EST_Track

friend

Definition at line 158 of file EST_TrackMap.h.

The documentation for this class was generated from the following files:

- include/EST_TrackMap.h
- speech_class/EST_TrackMap.cc